;
layui.config({
	base: "../../../admin/js/layuiPlugins/"
}).use(['form', 'layer', 'jquery', 'laypage', 'element', 'table', 'laydate', 'laytpl', 'cascade'], function () {
	var form = layui.form,
		layer = layui.layer,
		laytpl = layui.laytpl,
		laypage = layui.laypage,
		$ = layui.jquery,
		table = layui.table,
		element = layui.element,
		laydate = layui.laydate,
		cascade = layui.cascade;
	//自定义验证
	form.verify({
		namelength: [
			/^.{0,18}$/,
			"长度限制在0-18个字符噢"
		]
	});
	//监听一级Tab切换
	element.on('tab(productTabBrief)', function (obj) {
		switch (obj.index) {
			case 0:
				tableVm.reload();
				break;
		}
	});
	var vm = function (obj) {
		var _this = this;
		_this.dataId = obj.dataId || 'dataListId'; //数据表ID
		_this.elem = obj.elem || 'dataListBox'; //数据表容器
		_this.toolbar = obj.toolbar || '';
		_this.url = obj.url || ''; //数据表接口URL
		_this.page = obj.page; //分页
		_this.limit = obj.limit;
		_this.cols = obj.cols || []; //表头
		_this.done = obj.done || ''; //表头
		_this.formObj = {}; //当前表单对象
		_this.searchParameter = {}; //搜索参数
		_this.config = {};
		_this.where = obj.where;
		_this.config.dateTime = obj.dateTime;
		_this.dateTime = {
			year: 365 * 1 * 24 * 3600 * 1000,
			month: 30 * 1 * 24 * 3600 * 1000,
			day: 24 * 3600 * 1000,
		}
		_this.main();
	};
	//入口函数
	vm.prototype.main = function () {
		var _this = this;
		_this.initializationData()
	};
	//初始化表格
	vm.prototype.initializationData = function () {
		var _this = this;
		_this.dataListObj = table.render({
			id: _this.dataId,
			elem: _this.elem,
			toolbar: _this.toolbar,
			defaultToolbar: ['filter'],
			url: _this.url,
			page: _this.page,
			cols: _this.cols,
			done: _this.done,
			where: $.extend(_this.where, _this.searchParameter),
			limit: _this.limit,
		});
	};
	//重新加载数据表
	vm.prototype.reload = function () {
		var _this = this;
		_this.dataListObj = table.reload(_this.dataId, { //执行重载数据表
			where: _this.searchParameter,
			page: {
				curr: 1
			}
		});
	};
	//初始化组件
	vm.prototype.initializationModule = function (obj) {
		var _this = this;
		$.ajax({
			url: obj.url,
			data: obj.data,
			success: function (res) {
				var html = '<option value="">' + obj.prompt + '</option>';
				for (var i in res.data) {
					html += '<option value="' + res.data[i].id + '">' + res.data[i].name +
						'</option>';
				}
				$(obj.elem).html(html);
				form.render();
			}
		});
	};
	//初始化事件监听
	vm.prototype.eventMonitor = function (id) {
		var _this = this;
		//监听搜索表单事件
		if (typeof (_this.formEvent) == "object") {
			form.on('submit(' + _this.formEvent + ')', function (obj) {
				_this.formInfoSearch(_this.formEvent, obj);
				return false;
			});
		}
		return _this;
	};
	//搜索处理函数
	vm.prototype.formInfoSearch = function(id, obj) {
		var _this = this;
		_this.searchParameter = obj.field;
		if (obj.field.dateRange) {
			_this.searchParameter.startDate = obj.field.dateRange.substring(0, 10);
			_this.searchParameter.endDate = obj.field.dateRange.substring(13, 23);
		}else{
			_this.searchParameter.startDate = "";
			_this.searchParameter.endDate = "";
		}
		delete _this.searchParameter.dateRange;
		_this.reload();
	};
	
	//渲染时间选择器
	vm.prototype.showTimeSelect = function() {
		var _this = this;
		laydate.render({
			elem: _this.datePicker,
			range: true
		});
	};
	//jquer事件绑定
	vm.prototype.$event = function () {
		var _this = this;
		$(_this.dataExportBtn).on("click", function (e) {
			_this.dataExport();
		});
	};
	//数据导出处理函数
	vm.prototype.dataExport = function () {
		var _this = this;
		_this.downloadParameter = '?';
		for (var i in _this.dataListObj.config.where) {
			_this.downloadParameter += "&" + i + '=' + _this.dataListObj.config.where[i];
		}
		_this.startDownload();
	};
	//启动下载
	vm.prototype.startDownload = function () {
		var _this = this;
		window.open(window.hywa.config.href + window.hywa.config.port[_this.dataDownload] + _this.downloadParameter);
	};

	//模板引擎
	function typeTpl(obj) {
		laytpl(selectTpl.innerHTML).render(obj, function (html) {
			$(obj.elem).html(html);
			form.render();
		});
	}

	// 表格列表
	let tableId = "tableData";
	var tableVm = new vm({
		dataId: 'tableData',
		elem: '#tableData',
		url: 'mesTableUrl',
		toolbar: '#toolbar',
		dateTime: {
			year: 1,
			day: 1,
		},
		page: true,
		cols: [
			[{
				field: 'publishedTime',
				title: '发布时间',
				align: 'center'
			}, {
				field: 'title',
				title: '公共标题',
			}, {
				field: 'auther',
				title: '发布人',
				align: 'center'
			}, {
				field: 'isUserble',
				title: '是否可用',
				align: 'center',
				sort: true,
				templet: '<div>{{# d.checked = ((d.isUserble == 0)? "checked" : ""); }}<input type="checkbox" id="{{d.id}}" value="{{d.isUserble}}" lay-skin="switch" lay-text="是|否" lay-filter="isUserble" {{d.checked}}></div>',
				width: 100
			}, {
				field: 'operating',
				title: '操作',
				toolbar: "#operatingTool",
				align: 'center',
				fixed: 'right',
				width: 80
			}]
		],
		done: function() {
			if (!layui.data('auth').data.add) {
				$('.add-btn').hide();
			}
		}
	});
	//初始化事件监听
	tableVm.formEvent = ['tableSearch'];
	tableVm.eventMonitor();
	tableVm.$event();
	tableVm.datePicker = '#datePicker'; //时间容器
	tableVm.showTimeSelect();

	//监听头部工具栏
	table.on('toolbar(' + tableId + ')', function (obj) {
		switch (obj.event) {
			case 'add':
				var index = layer.open({
					type: 2,
					title: "新增",
					area: ['1200px', '800px'],
					maxmin: true,
					content: 'add_change.html',
					btn: ['确认发表', '取消'],
					yes: function (index, layero) {
						var submit = layero.find('iframe').contents().find("#formSubmit");
						submit.click();
					},
				});
				layer.full(index);
				break;
		};
	});
	//可用性修改
	form.on('switch(isUserble)', function (data) {
		var field = {
			id: data.elem.id,
			isUserble: data.value == 0 ? 1 : 0,
		}
		$.ajax({
			type: 'post',
			url: 'mesStatusUrl',
			data: JSON.stringify(field),
			contentType: 'application/json',
			success: function (res) {
				if (!(res.code - 0)) {
					layer.msg(res.msg, {
						icon: 1
					});
					tableVm.reload();
				} else {
					data.elem.checked = !data.elem.checked;
					form.render();
				}
			}
		});
	});
	//工具条处理
	function toolOperating(name, obj) {
		if (obj.event === 'del') { //删除
			layer.confirm('真的删除吗？', function (index) {
				layer.close(index);
				var index = layer.msg('删除中，请稍候', {
					icon: 16,
					time: false,
					shade: 0.8
				});
				$.ajax({
					type: 'delete',
					url: 'del_' + name + '?id=' + obj.data.id,
					success: function (res) {
						if (!(res.code - 0)) {
							obj.del();
							layer.close(index);
							layer.msg(res.msg, {
								icon: 1
							});
							table.reload(name);
						} else {
							layer.msg(res.msg, {
								icon: 2
							});
						}
					}
				});
			});
		} else if (obj.event === 'edit') { //修改
			var index = layer.open({
				type: 2,
				title: "修改",
				area: ['1200px', '800px'],
				maxmin: true,
				content: 'add_change.html?id=' + obj.data.id,
				btn: ['确认发表', '取消'],
				yes: function (index, layero) {
					var submit = layero.find('iframe').contents().find("#formSubmit");
					submit.click();
				},
			});
			layer.full(index);
		}
	}
	//监听事件条
	table.on('tool(' + tableId + ')', function (obj) {
		toolOperating(tableId, obj);
	});
});